REM **********************************************************************
REM ***   Beispielprogramm in BASIC fr die PC-Karte DA 1256           ***
REM **********************************************************************

PORT = &H100                            ' Adresse der Karte
NULLPUNKT = 0                           ' Niedrigster Strom
ENDWERT = 20                            ' Hchster Strom

REM === Initialisierung ===
FOR I = 0 TO 7
  OUT PORT, 0                           ' Alle Ausgnge auf niedrigsten
  OUT PORT + 1, I * 256                 ' Strom setzen
NEXT I

T$ = ""
GOSUB SCRN
DO
  T$ = INKEY$
  IF LEN(T$) = 2 THEN
    IF ASC(RIGHT$(T$, 1)) >= 59 AND ASC(RIGHT$(T$, 1)) <= 66 THEN
      KANAL = ASC(RIGHT$(T$, 1)) - 59
      CLS
      LOCATE 14, 12
      COLOR 0, 7
      PRINT "KANAL "; KANAL
      COLOR 7, 0
      LOCATE 15, 12
      PRINT "Bitte Stromwert eingeben (zw "; NULLPUNKT; " u. "; ENDWERT; " mA) :";
      INPUT WERT
      GOSUB OPUT
      GOSUB SCRN
    END IF
  END IF
LOOP UNTIL RIGHT$(T$, 1) = CHR$(68)
CLS
END

REM === Bildschirmausgabe ===
SCRN:
  CLS
  COLOR 0, 7
  FOR I = 0 TO 7
    LOCATE 4 + 2 * I, 30
    PRINT " F"; I + 1; "  = Kanal "; I; " "
  NEXT I
  LOCATE 4 + 2 * I, 30
  PRINT " F10 = ENDE        "
  COLOR 7, 0
RETURN

REM === Ausgabe des Wertes ===
OPUT:
  IF WERT > ENDWERT THEN WERT = ENDWERT ' Wert eingrenzen
  IF WERT < NULLPUNKT THEN WERT = NULLPUNKT
  WERT1 = 4095 / (ENDWERT - NULLPUNKT)  ' Wert umrechnen
  WERT = INT((WERT - NULLPUNKT) * WERT1)
  OUT PORT, (WERT AND &HFF)             ' Ausgabe des Spannungswertes
  OUT PORT + 1, (KANAL * 16) + (((WERT AND &HF00) / 256))
RETURN

